"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var core_1 = require("@blueprintjs/core");
var utils_1 = require("react-jsonschema-form/lib/utils");
var FieldTemplate = /** @class */ (function (_super) {
    tslib_1.__extends(FieldTemplate, _super);
    function FieldTemplate() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onKeyChange = function (event) {
            _this.props.onKeyChange(event.target.value);
        };
        return _this;
    }
    FieldTemplate.prototype.render = function () {
        var _a = this.props, children = _a.children, hidden = _a.hidden;
        if (hidden) {
            return (React.createElement("div", { className: 'hidden' }, children));
        }
        var _b = this.props, classNames = _b.classNames, displayLabel = _b.displayLabel, id = _b.id, label = _b.label, required = _b.required, errors = _b.errors, _c = _b.rawErrors, rawErrors = _c === void 0 ? [] : _c, help = _b.help, rawHelp = _b.rawHelp, schema = _b.schema;
        var value = (React.createElement(core_1.FormGroup, { className: classNames, labelInfo: required ? '(required)' : undefined, labelFor: id, label: displayLabel ? label : undefined, intent: rawErrors.length ? 'danger' : 'none', helperText: rawErrors.length || rawHelp ? (React.createElement(React.Fragment, null,
                errors,
                help)) : undefined }, children));
        var additional = schema.hasOwnProperty(utils_1.ADDITIONAL_PROPERTY_FLAG);
        if (!additional) {
            return value;
        }
        var _d = this.props, disabled = _d.disabled, readonly = _d.readonly, onDropPropertyClick = _d.onDropPropertyClick;
        return (React.createElement("div", { className: 'rjsf-bp3-additional-property' },
            React.createElement("div", { className: 'rjsf-bp3-additional-property-key' },
                React.createElement(core_1.FormGroup, { className: classNames, labelFor: id + "-key", label: label + " Key" },
                    React.createElement(core_1.InputGroup, { defaultValue: label, id: id + "-key", onBlur: this._onKeyChange }))),
            React.createElement("div", { className: 'rjsf-bp3-additional-property-value' }, value),
            React.createElement("div", { className: 'rjsf-bp3-additional-property-remove' },
                React.createElement(core_1.Button, { icon: 'cross', intent: 'danger', tabIndex: -1, disabled: disabled || readonly, onClick: onDropPropertyClick(label) }))));
    };
    return FieldTemplate;
}(React.Component));
exports.FieldTemplate = FieldTemplate;
//# sourceMappingURL=FieldTemplate.js.map