"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("react-jsonschema-form/lib/utils");
// Copypaste from react-jsonschema-form/src/components/widgets/SelectWidget.js
var nums = new Set(["number", "integer"]);
exports.processValue = function (schema, value) {
    // "enum" is a reserved word, so only "type" and "items" can be destructured
    var type = schema.type, items = schema.items;
    if (value === "") {
        return undefined;
    }
    else if (type === "array" && items && nums.has(items.type)) {
        return value.map(utils_1.asNumber);
    }
    else if (type === "boolean") {
        return value === "true";
    }
    else if (type === "number") {
        return utils_1.asNumber(value);
    }
    // If type is undefined, but an enum is present, try and infer the type from
    // the enum values
    if (schema.enum) {
        if (schema.enum.every(function (x) { return utils_1.guessType(x) === "number"; })) {
            return utils_1.asNumber(value);
        }
        else if (schema.enum.every(function (x) { return utils_1.guessType(x) === "boolean"; })) {
            return value === "true";
        }
    }
    return value;
};
exports.getValue = function (event, multiple) {
    if (multiple) {
        return [].slice
            .call(event.target.options)
            .filter(function (o) { return o.selected; })
            .map(function (o) { return o.value; });
    }
    else {
        return event.target.value;
    }
};
//# sourceMappingURL=utils.js.map