"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var core_1 = require("@blueprintjs/core");
// Copypaste from react-jsonschema-form/src/components/widgets/CheckboxWidget.js
function schemaRequiresTrueValue(schema) {
    // Check if const is a truthy value
    if (schema.const) {
        return true;
    }
    // Check if an enum has a single value of true
    if (schema.enum && schema.enum.length === 1 && schema.enum[0] === true) {
        return true;
    }
    // If anyOf has a single value, evaluate the subschema
    if (schema.anyOf && schema.anyOf.length === 1) {
        return schemaRequiresTrueValue(schema.anyOf[0]);
    }
    // If oneOf has a single value, evaluate the subschema
    if (schema.oneOf && schema.oneOf.length === 1) {
        return schemaRequiresTrueValue(schema.oneOf[0]);
    }
    // Evaluate each subschema in allOf, to see if one of them requires a true
    // value
    if (schema.allOf) {
        return schema.allOf.some(schemaRequiresTrueValue);
    }
    return true;
}
var CheckboxWidget = /** @class */ (function (_super) {
    tslib_1.__extends(CheckboxWidget, _super);
    function CheckboxWidget() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onChange = function (event) {
            return _this.props.onChange(event.target.checked);
        };
        _this._onBlur = function (event) {
            return _this.props.onBlur && _this.props.onBlur(_this.props.id, event.target.checked);
        };
        _this._onFocus = function (event) {
            return _this.props.onFocus && _this.props.onFocus(_this.props.id, event.target.checked);
        };
        return _this;
    }
    CheckboxWidget.prototype.render = function () {
        var _a = this.props, value = _a.value, disabled = _a.disabled, readonly = _a.readonly, autofocus = _a.autofocus, schema = _a.schema, id = _a.id, label = _a.label;
        return (React.createElement(core_1.Checkbox, tslib_1.__assign({ checked: typeof value === 'undefined' ? false : value, disabled: disabled || readonly, autoFocus: autofocus, required: schemaRequiresTrueValue(schema), onChange: this._onChange, onBlur: this._onBlur, onFocus: this._onFocus }, { id: id, label: label })));
    };
    return CheckboxWidget;
}(React.Component));
exports.CheckboxWidget = CheckboxWidget;
//# sourceMappingURL=CheckboxWidget.js.map