"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var core_1 = require("@blueprintjs/core");
var utils_1 = require("../utils");
var SelectWidget = /** @class */ (function (_super) {
    tslib_1.__extends(SelectWidget, _super);
    function SelectWidget() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onBlur = function (event) {
            var _a = _this.props, id = _a.id, multiple = _a.multiple, onBlur = _a.onBlur, schema = _a.schema;
            if (!onBlur) {
                return;
            }
            var value = utils_1.getValue(event, multiple);
            onBlur(id, utils_1.processValue(schema, value));
        };
        _this._onFocus = function (event) {
            var _a = _this.props, id = _a.id, multiple = _a.multiple, onFocus = _a.onFocus, schema = _a.schema;
            if (!onFocus) {
                return;
            }
            var value = utils_1.getValue(event, multiple);
            onFocus(id, utils_1.processValue(schema, value));
        };
        _this._onChange = function (event) {
            var _a = _this.props, multiple = _a.multiple, onChange = _a.onChange, schema = _a.schema;
            if (!onChange) {
                return;
            }
            var value = utils_1.getValue(event, multiple);
            onChange(utils_1.processValue(schema, value));
        };
        return _this;
    }
    SelectWidget.prototype.render = function () {
        var _a = this.props, autofocus = _a.autofocus, disabled = _a.disabled, multiple = _a.multiple, id = _a.id, options = _a.options, placeholder = _a.placeholder, readonly = _a.readonly, required = _a.required, schema = _a.schema, value = _a.value;
        var enumOptions = options.enumOptions, enumDisabled = options.enumDisabled, _b = options.fill, fill = _b === void 0 ? true : _b;
        var emptyValue = multiple ? [] : '';
        return (React.createElement(core_1.HTMLSelect, tslib_1.__assign({ autoFocus: autofocus, value: typeof value === 'undefined' ? emptyValue : value, disabled: disabled || readonly, onBlur: this._onBlur, onFocus: this._onFocus, onChange: this._onChange }, { id: id, multiple: multiple, required: required, fill: fill }),
            !multiple && !schema.default && React.createElement("option", { value: "" }, placeholder),
            enumOptions.map(function (_a, index) {
                var value = _a.value, label = _a.label;
                var disabled = enumDisabled ? enumDisabled.indexOf(value) > -1 : false;
                return (React.createElement("option", { key: index, value: value, disabled: disabled }, label));
            })));
    };
    return SelectWidget;
}(React.Component));
exports.SelectWidget = SelectWidget;
//# sourceMappingURL=SelectWidget.js.map