import * as tslib_1 from "tslib";
import * as React from 'react';
import { Button } from '@blueprintjs/core';
import BaseForm from 'react-jsonschema-form';
import { ArrayFieldTemplate } from './ArrayFieldTemplate';
import { ErrorList } from './ErrorList';
import { FieldTemplate } from './FieldTemplate';
import { ObjectFieldTemplate } from './ObjectFieldTemplate';
import * as customWidgets from './widgets';
import * as customFields from './fields';
var _Form = /** @class */ (function (_super) {
    tslib_1.__extends(_Form, _super);
    function _Form() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _Form.prototype.render = function () {
        var _a = this.props, children = _a.children, fields = _a.fields, widgets = _a.widgets, forwardedRef = _a.forwardedRef, props = tslib_1.__rest(_a, ["children", "fields", "widgets", "forwardedRef"]);
        return (React.createElement(BaseForm, tslib_1.__assign({}, props, { widgets: tslib_1.__assign({}, customWidgets, widgets), fields: tslib_1.__assign({}, customFields, fields), ref: forwardedRef }), children || (React.createElement(Button, { type: 'submit', text: 'Submit', intent: 'primary', disabled: props.disabled }))));
    };
    _Form.defaultProps = {
        ArrayFieldTemplate: ArrayFieldTemplate,
        ErrorList: ErrorList,
        FieldTemplate: FieldTemplate,
        ObjectFieldTemplate: ObjectFieldTemplate,
        widgets: {},
        fields: {}
    };
    return _Form;
}(React.Component));
export { _Form };
export var Form = React.forwardRef(function (props, ref) { return (React.createElement(_Form, tslib_1.__assign({}, props, { forwardedRef: ref }))); });
//# sourceMappingURL=Form.js.map