import * as tslib_1 from "tslib";
import * as React from 'react';
import { Classes, InputGroup, NumericInput } from '@blueprintjs/core';
var BaseInput = /** @class */ (function (_super) {
    tslib_1.__extends(BaseInput, _super);
    function BaseInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onChange = function (event) {
            return _this.props.onChange(event.target.value === '' ? _this.props.options.emptyValue : event.target.value);
        };
        _this._onBlur = function (event) {
            return _this.props.onBlur && _this.props.onBlur(_this.props.id, event.target.value);
        };
        _this._onFocus = function (event) {
            return _this.props.onFocus && _this.props.onFocus(_this.props.id, event.target.value);
        };
        _this._onValueChange = function (value) {
            return _this.props.onChange(value);
        };
        return _this;
    }
    BaseInput.prototype.render = function () {
        var _a = this.props, value = _a.value, readonly = _a.readonly, disabled = _a.disabled, autofocus = _a.autofocus, onBlur = _a.onBlur, onFocus = _a.onFocus, options = _a.options, schema = _a.schema, formContext = _a.formContext, registry = _a.registry, _b = _a.rawErrors, rawErrors = _b === void 0 ? [] : _b, inputProps = tslib_1.__rest(_a, ["value", "readonly", "disabled", "autofocus", "onBlur", "onFocus", "options", "schema", "formContext", "registry", "rawErrors"]);
        var _c = options.fill, fill = _c === void 0 ? true : _c;
        Object.assign(inputProps, inputTypeProps(this.props));
        if (inputProps.type === 'number') {
            return (React.createElement(NumericInput, tslib_1.__assign({ readOnly: readonly, autoFocus: autofocus, disabled: disabled, value: value == null ? '' : value, defaultValue: undefined, onValueChange: this._onValueChange, intent: rawErrors.length ? 'danger' : 'none', max: schema.maximum, min: schema.minimum }, inputProps, inputTypeProps(this.props), { 
                // Prevent wrapped input element getting an additional spinner
                type: undefined }, stepProps(schema), { fill: fill })));
        }
        return (React.createElement(InputGroup, tslib_1.__assign({ className: "" + (fill ? Classes.FILL : ''), readOnly: readonly, autoFocus: autofocus, disabled: disabled, value: value == null ? '' : value, defaultValue: undefined, intent: rawErrors.length ? 'danger' : 'none' }, inputProps, inputTypeProps(this.props), { onChange: this._onChange, onBlur: this._onBlur, onFocus: this._onFocus })));
    };
    return BaseInput;
}(React.Component));
export { BaseInput };
var inputTypeProps = function (props) {
    if (props.options.inputType) {
        return { type: props.options.inputType };
    }
    if (!props.type) {
        if (props.schema.type === 'number') {
            return { type: 'number', step: 'any' };
        }
        if (props.schema.type === 'integer') {
            return { type: 'number', step: '1' };
        }
        return { type: 'text' };
    }
};
var stepProps = function (schema) {
    return schema.multipleOf ? {
        stepSize: schema.multipleOf,
        majorStepSize: schema.multipleOf * 10,
        minorStepSize: null
    } : {
        minorStepSize: 0.01
    };
};
//# sourceMappingURL=BaseInput.js.map