import * as tslib_1 from "tslib";
import * as React from 'react';
import { TextArea } from '@blueprintjs/core';
var TextareaWidget = /** @class */ (function (_super) {
    tslib_1.__extends(TextareaWidget, _super);
    function TextareaWidget() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onChange = function (event) {
            return _this.props.onChange(event.target.value === '' ? _this.props.options.emptyValue : event.target.value);
        };
        _this._onBlur = function (event) {
            return _this.props.onBlur && _this.props.onBlur(_this.props.id, event.target.value);
        };
        _this._onFocus = function (event) {
            return _this.props.onFocus && _this.props.onFocus(_this.props.id, event.target.value);
        };
        return _this;
    }
    TextareaWidget.prototype.render = function () {
        var _a = this.props, id = _a.id, value = _a.value, disabled = _a.disabled, placeholder = _a.placeholder, required = _a.required, readonly = _a.readonly, autofocus = _a.autofocus, options = _a.options;
        var _b = options.fill, fill = _b === void 0 ? true : _b, rows = options.rows;
        return (React.createElement(TextArea, tslib_1.__assign({ value: value == null ? '' : value, onChange: this._onChange, onBlur: this._onBlur, onFocus: this._onFocus, readOnly: readonly, autoFocus: autofocus }, { id: id, disabled: disabled, placeholder: placeholder, required: required, fill: fill, rows: rows })));
    };
    return TextareaWidget;
}(React.Component));
export { TextareaWidget };
//# sourceMappingURL=TextareaWidget.js.map