declare module 'react-jsonschema-form/lib/utils' {
  import { UiSchema, FieldProps } from 'react-jsonschema-form';

  export function asNumber(value: any): string;
  export function guessType(value: any): string;
  export function getUiOptions(uiSchema: UiSchema): {
    expandable: boolean
  };

  export const ADDITIONAL_PROPERTY_FLAG: string;
}

declare module 'react-jsonschema-form/lib/components/fields/MultiSchemaField' {
  import { Component, ChangeEventHandler } from 'react';
  import { FieldProps } from 'react-jsonschema-form';
  import { JSONSchema6 } from 'json-schema';

  type Props = FieldProps & {
    options: Array<JSONSchema6>
  }

  type State = {
    selectedOption: number;
  }

  class MultiSchemaField extends React.Component<Props, State> {
    onOptionChange: ChangeEventHandler<HTMLSelectElement>;
  }

  export default MultiSchemaField;
}

declare module 'react-jsonschema-form/lib/components/widgets/FileWidget' {
  import { Component, ChangeEventHandler } from 'react';
  import { WidgetProps } from 'react-jsonschema-form';

  type Props = WidgetProps & {
    multiple: boolean;
  };

  type State = {
    filesInfo: any[];
  }

  class FileWidget extends React.Component<Props, State> {
    onChange: ChangeEventHandler<HTMLInputElement>;
  }

  export default FileWidget;
}
